using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PingTest.WebReference;
using System.Net;

namespace PingTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnPing_Click(object sender, EventArgs e)
        {
            myService webService = new myService();
            // Create the network credentials and assign them to the service credentials
            NetworkCredential netCredential = new NetworkCredential(txtUserName.Text, txtPassword.Text);
            Uri uri = new Uri(txtURI.Text);
            ICredentials credentials = netCredential.GetCredential(uri, "Basic");
            webService.Credentials = credentials;
            webService.PreAuthenticate = true;

            PingRequest ping = new PingRequest();
            ping.appVersion = "2.3.0.6";
            ping.deviceName = "Nick";
            ping.location = "TEST";
            ping.userName = "ADMIN00";
            PingResponse response = null;
            try
            {
                response = webService.Ping(ping);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            if(response != null)
                MessageBox.Show(response.msgName);
        }
    }

    class myService : tslService
    {
        // THIS MUST BE PUT INTO reference.cs for basic HTTP authentication to work!! 
        protected override System.Net.WebRequest GetWebRequest(Uri uri)
        {
            System.Net.HttpWebRequest request;
            request = (System.Net.HttpWebRequest)base.GetWebRequest(uri);

            if (PreAuthenticate)
            {
                System.Net.NetworkCredential networkCredentials =
                    Credentials.GetCredential(uri, "Basic");

                if (networkCredentials != null)
                {
                    byte[] credentialBuffer = new System.Text.UTF8Encoding().GetBytes(
                        networkCredentials.UserName + ":" +
                        networkCredentials.Password);
                    request.Headers["Authorization"] =
                        "Basic " + Convert.ToBase64String(credentialBuffer);
                }
                else
                {
                    throw new ApplicationException("No network credentials");
                }
            }
            return request;
        }
    }
}